/*
 * browser.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#include "browser.h"

/********************************
cBrowserSub
********************************/
cBrowserSub::cBrowserSub(const char *title, const char *url)
  :cOsdMenu(title)
{
  goUrl(url);
}

void cBrowserSub::goUrl(const char *url)
{
  FILE *file;
  char puffer[100000];
  char *buffer;
  int i, ch;


  asprintf(&buffer, "lynx -dump -width 56 %s", url);

  file=popen(buffer, "r");
  ch = fgetc(file);
  for(i=0 ;(feof(file) == 0); i++)
  {
    puffer[i] = (char)ch;
    ch = fgetc(file);
  }
  puffer[i] = '\0';

  linknr = 1;
  Add(linkInput = new cMenuEditIntItem("Link ", &linknr));
  Add(body = new cMenuTextItem(parseLinks(puffer), 1, 3, Setup.OSDwidth -2, Height() - 5, clrWhite, clrBackground, fontOsd));
  SetStatus("Press BACK to go back to main menu");
  SetHelp("Follow Link");
  SetCurrent(body);
}

const char * cBrowserSub::parseLinks(const char *text)
{
  char buffer1[1000000];
  char buffer2[50000];
  char ibuffer[1000] = "1";
  int i = 1;
  char *pos;
  bool found = true;
  strcpy(buffer1, text);
  sprintf(buffer1, "%s\n", strstr(buffer1, "References\n\n   "));
   while (found==true) {
        sprintf(ibuffer, "%i. ", i);
        if (!strstr(buffer1, ibuffer)   ) { found=false; break;}
        sprintf(buffer1, "%s\n", strstr(buffer1, ibuffer));
        pos = strstr(buffer1, "\n") + 1;
        int index;
        index = buffer1 - pos; if (index<0) index = -index;
        snprintf(buffer2, index, "%s\n", buffer1);
        buffer2[index] = '\0';
        const char *buf1;
        buf1 = strchr(buffer2, '.') + 2;
        strcpy(links[i], buf1);
         i++;
   }
  return text;
}

eOSState cBrowserSub::ProcessKey(eKeys Key)
{
  eOSState state = cOsdMenu::ProcessKey(Key);
  if (state == osUnknown) {
    switch (Key) {
    default: break;
    case kOk:
      if (this->Current() == 0) { Clear(); goUrl(links[linknr]); RefreshCurrent(); Display(); }
    break;

    case kRed:
      if (this->Current() == 1) { SetCurrent(linkInput), SetStatus("Set link and press OK to follow"); SetHelp(NULL); }  
    break;
    }
  }
  return state;
}

/********************************
cBrowserMain
********************************/
cBrowserMain::cBrowserMain(const char *Title)
:cOsdMenu("Browser")
{
  data[0] = 'h'; data[1] = 't'; data[2] = 't'; data[3] = 'p';
  data[4] = ':'; data[5] = '/'; data[6] = '/'; data[7] = 'w';
  data[8] = 'w'; data[9] = 'w'; data[10] = '.';
  Add(new cMenuEditStrItem("Url", data, sizeof(data)-1, "abcdefghijklmnopqrstuvwxyz0123456789:/.?&@-_"));

  FILE *file;
  char puffer[100000];
  const char *cdir = cPlugin::ConfigDirectory();
  strcpy(puffer, cdir);
  strcat(puffer, "/browser.conf");
  file = fopen(puffer, "r");
  if (file) {
    int i = 1;

    while (fgets(puffer, 500, file) != NULL) {
      strcpy(bookmarks[i], puffer);
      Add(new cOsdItem(puffer));
      i++;
    }
    puffer[1] = 0;
    i = 1;
  }

}

cBrowserMain::~cBrowserMain(void)
{

}

eOSState cBrowserMain::ProcessKey(eKeys Key)
{
  eOSState state = cOsdMenu::ProcessKey(Key);
  if (state == osUnknown) {
    switch (Key) {
    default: break;
    case kOk:
      if (!HasSubMenu()) { if (this->Current() != 0) AddSubMenu(new cBrowserSub("Browser", bookmarks[this->Current()])); else AddSubMenu(new cBrowserSub("Browser", data)); }
     break;
    }
  }
  return state;
}


cPluginBrowser::cPluginBrowser(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
}

cPluginBrowser::~cPluginBrowser()
{
  // Clean up after yourself!
}

const char *cPluginBrowser::CommandLineHelp(void)
{
  // Return a string that describes all known command line options.
  return NULL;
}

bool cPluginBrowser::ProcessArgs(int argc, char *argv[])
{
  // Implement command line argument processing here if applicable.
  return true;
}

bool cPluginBrowser::Start(void)
{
  // Start any background activities the plugin shall perform.
  return true;
}

void cPluginBrowser::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

cOsdObject *cPluginBrowser::MainMenuAction(void)
{
  // Perform the action when selected from the main VDR menu.
  return new cBrowserMain("Browser");
}

cMenuSetupPage *cPluginBrowser::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return NULL;
}

bool cPluginBrowser::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
  return false;
}

VDRPLUGINCREATOR(cPluginBrowser); // Don't touch this!
