#include <vdr/plugin.h>
#include <vdr/thread.h>
#include <vdr/player.h>
#include <vdr/osd.h>
#include <vdr/interface.h>

#include "/usr/include/fcntl.h"
#include "/usr/include/unistd.h"
#include "/usr/include/string.h"
#include "/usr/include/stdlib.h"
#include "/usr/include/stdio.h"

static const char *VERSION        = "0.1";
static const char *DESCRIPTION    = "A simple OSD Textbrowser";
static const char *MAINMENUENTRY  = "Browser";


class cPluginBrowser : public cPlugin {
private:
  // Add any member variables or functions you may need here.
public:
  cPluginBrowser(void);
  virtual ~cPluginBrowser();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return DESCRIPTION; }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Start(void);
  virtual void Housekeeping(void);
  virtual const char *MainMenuEntry(void) { return MAINMENUENTRY; }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
};

class cBrowserSub : public cOsdMenu
{
 private:
  cMenuEditIntItem *linkInput;
 public:
    virtual eOSState ProcessKey(eKeys Key);
    cBrowserSub(const char *Title, const char *url);
    int linknr;
    const char * parseLinks(const char *text);
    char links[1000][500];
    cMenuTextItem *body;
    void goUrl(const char *url);
};


class cBrowserMain : public cOsdMenu
{
 private:
  cBrowserSub *browserSub;
 public:
  cBrowserMain(const char *Title);
  virtual ~cBrowserMain();
  virtual eOSState ProcessKey(eKeys Key);
  char data[100];
  char bookmarks[100][500];
  const char *title;
};
